
/**
 * Klasse zur Beschreibung des Karol mit Rucksack
 *
 * @author Klaus Reinold
 * @version 1.0
 */
public class Rucksackkarol extends ROBOTER
{
    int anzahlZiegel;

    /**
     * Konstruktor des Rucksackkarol
     * @param inWelt die Welt, in der der Roboter lebt
     * @param anzahlZiegelNeu die Anzahl der Ziegel, die Karol zu Beginn im Rucksack hat
     */
    Rucksackkarol(WELT inWelt, int anzahlZiegelNeu)
    {
       super(inWelt);
       anzahlZiegel = anzahlZiegelNeu;
    }

	/**
     * Legt einent Ziegel ab, wenn noch welche im Rucksack sind
     */
    @Override public void Hinlegen()
    {
        if (anzahlZiegel > 0)
        {
            super.Hinlegen();
            anzahlZiegel = anzahlZiegel-1;
        }
        else
        {
            System.out.println("Keine Ziegel vorhanden");
        }
    }
    
    /**
	 * Hebt einen Ziegel auf und zählt dabei mit
     */
    @Override public void Aufheben()
    {
        if (super.IstZiegel())
        {
            super.Aufheben();
            anzahlZiegel = anzahlZiegel+1;
        }
    }
}
