# -*- coding: utf-8 -*-
"""
Created on Sat Dec 27 12:33:57 2020

@author: Klaus Reinold
"""

from graphics_and_games_klassen import Rechteck
from random import Random
        

class Zufall:
    """
    Klasse zur Erzeugung einer Zufallszahl.
    """


    def __init__(self):
        """
        Initialisierungsroutine für Objekte der Klasse Zufall
        """
        self.zzgenerator = Random()
    

    
    def GanzzahlGeben(self, n):
        """
        Erzeugung einer zufälligen Ganzzahl aus dem Intervall [0, n[
        """
        return self.zzgenerator.randint(0,n)
    




class RechteckMondrian(Rechteck):
    """
    Rechtecke, inspiriert von Mondrian
    """

    
    def __init__(self,farbe):
        """
        Konstruktor für Objekte der Klasse Rechteck_Mondrian
        """
        super().__init__()
        zufall = Zufall()
        self.GroesseSetzen((zufall.GanzzahlGeben(4) + 1)*20, (zufall.GanzzahlGeben(4) + 1)*20)
        self.PositionSetzen(zufall.GanzzahlGeben(10)*20,zufall.GanzzahlGeben(10)*20)
        self.FarbeSetzen(farbe)
    





class Bild:
    """
    Klasse zum Zeichnen eines Bildes.
    """
    
   
    def __init__(self, anzahl):
        """
        Konstruktor für Objekte der Klasse Bild
        """    
        self.zufall = Zufall()
        self.anzahlGelb = 0
        self.anzahlBlau = 0
        self.anzahlRot = 0
        self.anzahlSchwarz = 0
        self.BildZeichnen(anzahl)
    

    
    def FarbeGeben(self):
        """
        -- return zufällige Farbe
        """
        i = self.zufall.GanzzahlGeben(4)
        
        
        if i == 0: 
            return "rot"
        elif i==1: 
            return "schwarz"
        elif i==2: 
            return "blau"
        elif i==3: 
            return "gelb"
        else: 
            return None
        
    
    
    def BildZeichnen(self, anzahlRechtecke):
        """
        Methode zum Zeichnen eines Bildes
        """   
        self.anzahlGelb = 0
        self.anzahlBlau = 0
        self.anzahlRot = 0
        self.anzahlSchwarz = 0
        for i in range(anzahlRechtecke):
            farbe = self.FarbeGeben()
            RechteckMondrian(farbe)
            if farbe=="rot": 
                self.anzahlRot = self.anzahlRot + 1
            elif farbe=="gelb":
                self.anzahlGelb = self.anzahlGelb + 1
            elif farbe=="blau": 
                self.anzahlBlau = self.anzahlBlau + 1
            else: 
                self.anzahlSchwarz = self.anzahlSchwarz + 1   

       
        while self.anzahlRot == 0 or self.anzahlGelb == 0 or self.anzahlSchwarz==0 or self.anzahlBlau ==0:
            farbe = self.FarbeGeben()
            if farbe=="rot": 
                self.anzahlRot = self.anzahlRot + 1
            elif farbe=="gelb":
                self.anzahlGelb = self.anzahlGelb + 1
            elif farbe=="blau": 
                self.anzahlBlau = self.anzahlBlau + 1
            else: 
                self.anzahlSchwarz = self.anzahlSchwarz + 1   
            RechteckMondrian(farbe)
        

    
    
    def BildnameGeben(self):
        """
        Gibt den Bildnamen zurück
        -- return Bildname
        """    
        return "Komposition aus "+ str(self.anzahlRot) + " roten, " + str(self.anzahlBlau) + " blauen, "+ str(self.anzahlGelb) + " gelben und "+ str(self.anzahlSchwarz) + " schwarzen Rechtecken"
        


b = Bild(3)
print(b.BildnameGeben())