/*:
# **Kapitel 2.1**
## **Aufgabe 5 : Frei nach Mondrian**
Eine Künstlerin möchte inspiriert von den Werken von Mondrian (Aufgabe 1) Kunstwerke aus roten, gelben und schwarzen Rechtecken erstellen, anders als Mondrian ohne die Linien dazwischen. Um sich die Arbeit zu erleichtern, möchte sie die Bilderstellung automatisieren.\
a\
Die Klasse RECHTECK_MONDRIAN ist bereits fertig. Analysiert sie in Zweierteams und beschreibt euch gegenseitig, wie sie arbeitet. Verwendet die Begriffe Oberklasse, Unterklasse, Konstruktor, Aufruf des Oberklassenkonstruktors, Aufruf einer Oberklassenmethode, Zufallszahl.
*/
/**
Rechtecke, inspiriert von Mondrian

- author: Klaus Reinold
- version: 1.0
*/
class RechteckMondrian: Rechteck
{
    let zufall: Zufall

    /**
    Konstruktor für Objekte der Klasse Rechteck_Mondrian
    */
    init(farbe: String)
    {
        zufall = Zufall()
        super.init()
        GrößeSetzen(breite: (zufall.ZufallGanz(top: 4) + 1)*20, höhe: (zufall.ZufallGanz(top: 4) + 1)*20)
        PositionSetzen(x: zufall.ZufallGanz(top: 10)*20,y: zufall.ZufallGanz(top: 10)*20)
        FarbeSetzen(farbe: farbe)
    }
}
/*:
b\
In der Klasse BILD muss noch die Methode *BildZeichnen* gemäß dem nachfolgenden Struktogramm implementiert werden. Beschreibe, unter welchen Umständen beim Aufruf *BildZeichnen(20)* mehr als 20 Rechtecke gezeichnet werden.\
![Struktogramm](Struktogramm.png)\
c\
Ergänze in der Klasse BILD die Methode *BildZeichnen* gemäß dem Struktogramm.
*/
/**
Klasse zum Zeichnen eines Bildes.

- author: Klaus Reinold
- version: 1.0
*/
class Bild
{
    let zufall: Zufall
	var anzahlGelb: Int
	var anzahlBlau: Int
	var anzahlRot: Int
	var anzahlSchwarz: Int
   
    /**
    Konstruktor für Objekte der Klasse Bild
    */
    init(anzahl: Int)
    {
        zufall = Zufall()
        anzahlGelb = 0
        anzahlBlau = 0
        anzahlRot = 0
        anzahlSchwarz = 0
        BildZeichnen(anzahlRechtecke: anzahl)
    }

    /**
    Methode zur zufälligen Bestimmung einer Farbe
	- returns: Zufällige Farbe
    */
    func FarbeGeben() -> String
    {
        switch zufall.ZufallGanz(top: 4)
        {
            case 0: return "rot"
            case 1: return "schwarz"
            case 2: return "blau"
            case 3: return "gelb"
            default: return ""
        }
    }
    
    /**
    Methode zum Zeichnen eines Bildes
    */
    func BildZeichnen(anzahlRechtecke: Int)
    {
//#-editable-code
        anzahlGelb = 0
        anzahlBlau = 0
        anzahlRot = 0
        anzahlSchwarz = 0
        var farbe: String
        for _ in 0 ..< anzahlRechtecke
        {
            farbe = FarbeGeben()
            RechteckMondrian(farbe: farbe)
            if farbe=="rot"
            {
                anzahlRot = anzahlRot + 1
            }
            else if farbe=="gelb"
            {
                anzahlGelb = anzahlGelb + 1
            }
            else if farbe=="blau"
            {
                anzahlBlau = anzahlBlau + 1
            }
            else
            {
                anzahlSchwarz = anzahlSchwarz + 1
            }
        }
       
        while (anzahlRot == 0) || (anzahlGelb == 0) || (anzahlSchwarz == 0) || (anzahlBlau == 0)
        {
            farbe = FarbeGeben()
            if farbe == "rot"
            {
                anzahlRot = anzahlRot + 1
            }
            else if farbe == "gelb"
            {
                anzahlGelb = anzahlGelb + 1
            }
            else if farbe == "blau"
            {
                anzahlBlau = anzahlBlau + 1
            }
            else
            {
                anzahlSchwarz = anzahlSchwarz + 1
            }
            RechteckMondrian(farbe: farbe)
        }
//#-end-editable-code
    }
/*:
d\
Teste die Methode mit den Aufrufen *BildZeichnen(100)* und *BildZeichnen(0)*. Die Künstlerin hatte beabsichtigt, dass die Zeichnung dann endet, wenn mindestens ein Rechteck von jeder Farbe vorhanden ist. Zeichne ein berichtigtes Struktogramm des Abschnitts und berichtige die Methode entsprechend.\
e\
Das Werk soll automatisch benannt werden in der Form „Komposition aus ... roten, ... blauen, ... gelben und ... schwarzen Rechtecken“. Entwickle eine Methode mit Rückgabewert, die den Namen des zuletzt gezeichneten Bildes liefert.
*/
//#-editable-code
    func BildnameGeben() -> String
    {
        return "Komposition aus \(anzahlRot) roten, \(anzahlBlau) blauen, \(anzahlGelb) gelben und \(anzahlSchwarz) schwarzen Rechtecken"
    }
//#-end-editable-code
}
/*:
f\
Diskutiert in der Klasse, inwieweit ihr ein solches maschinell erstelltes Werk noch als Kunstwerk empfindet. Recherchiert aktuelle Beispiele, wie Rechner eingesetzt werden, um Kunstwerke zu erschaffen.
*/
//#-editable-code

Bild(anzahl: 30).BildnameGeben()


//#-end-editable-code
