/*:
# **Kapitel 2.1**
## **Aufgabe 6 Robot Karol mit Rucksack**
Karol ist es leid, unendlich viele Ziegel mit sich herumzuschleppen und dabei noch gut gelaunt zu wirken! Ab sofort hat er nur noch eine begrenzte Ziegelanzahl in einem Rucksack dabei, die zu Beginn festgelegt wird. Er legt nur so viele Ziegel hin, wie er dabei hat. Danach gibt er bei Aufruf der Methode *Hinlegen* jedesmal eine passende Fehlermeldung aus und macht ansonsten normal weiter.\
a\
Skizziere ein Klassendiagramm mit der Vererbungsbeziehung und den neuen Attributen und Methoden der Klasse RUCKSACKKAROL.\
b\
Implementiere und teste in einer selbstgewählten Aufgabenstellung.
*/

/**
Klasse zur Beschreibung des Karol mit Rucksack

- author: Klaus Reinold
- version: 1.0
*/
class Rucksackkarol: Roboter
{
    var anzahlZiegel: Int

    /**
     * Konstruktor des Rucksackkarol
     */
    init(inWelt:Welt, anzahlZiegelNeu: Int)
    {
       anzahlZiegel = anzahlZiegelNeu
       super.init(inWelt: inWelt)
    }

	/**
	Legt einent Ziegel ab, wenn noch welche im Rucksack sind
    */
    override func Hinlegen()
    {
        if anzahlZiegel > 0
        {
            super.Hinlegen()
            anzahlZiegel = anzahlZiegel - 1
        }
        else
        {
            print("Keine Ziegel vorhanden")
        }
    }
    
    /**
	Hebt einen Ziegel auf und zählt dabei mit
     */
    override func Aufheben()
    {
        if IstZiegel()
        {
            super.Aufheben()
            anzahlZiegel = anzahlZiegel + 1
        }
    }
}

class Arbeit
{
    var welt: Welt
    var karol: Roboter

    /**
    Erzeugt die Welt und den Roboter.
    */
    init()
    {
        welt = Welt (breite: 8, laenge: 10, hoehe: 5)
        karol = Rucksackkarol (inWelt: welt, anzahlZiegelNeu: 4)
    }
    
    /**
    Versucht, einen Ziegel mehr zu legen, als vorhanden
    */
    func Ausführen()
    {
    	for _ in 1...5
     	{
        	karol.Hinlegen()
        	karol.Schritt()
        }

    }
}

Arbeit().Ausführen()

